package com.example.helloaquestalk2;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import android.media.MediaPlayer;
import android.util.Log;
import android.widget.TextView;
import java.io.*;

import aquestalk2.AquesTalk2;	// AquesTalk2クラス 別途libAquesTalk2.soが必要

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
 //       setContentView(R.layout.activity_main);

        String koe = "ゆっくりしていってね？";
        int    speed = 90; // 発話速度　50-300　default:100
        int	   phontResID = R.raw.aq_robo;	// 声種
    	try {
    		// リソースからPhontデータを読み込み (デフォルトのPhontを使用するときは不要）
	    	InputStream	in = getResources().openRawResource(phontResID);
	    	int size = in.available();	// リソースのデータサイズ
	    	byte[] phontDat = new byte[size];
	    	in.read(phontDat);

	        // 音声合成
	    	AquesTalk2 aquestalk2 = new AquesTalk2();
	    	byte[] wav = aquestalk2.syntheWav(koe, speed, phontDat);
//	    	byte[] wav = aquestalk2.syntheWav(koe, speed, null);  //< デフォルトのPhontを使用する場合
//			byte[] wav = AquesTalk2.synthe(koe, speed, phontDat); //< 静的メソッドもOK
	    	
	    	if(wav.length==1){//生成エラー時には,長さ１で、先頭にエラーコードが返される 
	        	Log.v("AQTKAPP", "AquesTalk2 Synthe ERROR:"+wav[0]);
	    	}
	    	else {
	    		PlayWav(wav);//音声データを再生出力
	    	}
    	}catch (IOException e) {
		}
    	TextView textView = new TextView(this);
     	textView.setText("音声記号列："+koe
     			+" speed:"+speed
     			+" phont:"+getResources().getResourceEntryName(phontResID));
     	setContentView(textView);
    }
  private void PlayWav(byte[] wav) {
	  // 一旦ファイルに出力してから、MediaPlayerで再生
	  String tmpfilename = "tmp_hello.wav";
	  String packagename = removeSuffix(this.getClass().getName());
	  
      try {
          FileOutputStream fileOutputStream = openFileOutput(tmpfilename, MODE_PRIVATE);
          fileOutputStream.write(wav);
          fileOutputStream.close();
      } catch (IOException e) {
    	  Log.e("AQTKAPP", "ERR: FileOutputStream");
      }
      try {
          MediaPlayer mp = new MediaPlayer();
      	  // mp.reset();	// MediaPlayerインスタンスを複数回使うときは必要
          mp.setDataSource("/data/data/"+packagename+"/files/"+tmpfilename);
          mp.prepare();	//<<忘れると動かない　(-38,0)のようなエラーがでる
          mp.start();   
		} catch (IOException e) {
		}
  }

  public static String removeSuffix(String fileName) {
	    if (fileName == null)
	        return null;
	    int point = fileName.lastIndexOf(".");
	    if (point != -1) {
	        return fileName.substring(0, point);
	    } 
	    return fileName;
	}

}
